//Weapon_DualG36Cs.cs
//Scripting: Amad (ID 10716)
//Model: Pandan

//We already have the G36C datablocks, so we can skip all the way down here to the projectile and damage type
AddDamageType("DualG36Cs", //Name
'<bitmap:Add-Ons/Weapon_Dual_G36Cs/CI_2G36Cs> %1', //Suicide message (good luck getting this to trigger)
'%2 <bitmap:Add-Ons/Weapon_Dual_G36Cs/CI_2G36Cs> %1',0.05,1); //Kill message

datablock ProjectileData(DualG36CsProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 8; //Slightly lower than normal G36C, but not low enough to make them equal.
   directDamageType    = $DamageType::DualG36Cs;
   radiusDamageType    = $DamageType::DualG36Cs;

   brickExplosionRadius = 0;
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 3;
   brickExplosionMaxVolumeFloating = 5;
   brickExplosionImpact = true;

   impactImpulse    = 3;
   verticalImpulse = 10;
   explosion       = G36Cexplosion;

   muzzleVelocity   = 140;
   velInheritFactor = 1;

   armingDelay      = 0;
   lifetime         = 4000;
   fadeDelay        = 3500;
   bounceElasticity = 0.01;
   bounceFriction   = 0.99;
   isBallistic      = false;
   gravityMod       = 0;

   hasLight = false;

   uiName = "Dual G36C Bullet";
};

// Item //
datablock ItemData(DualG36Citem)
{
   category  = "Weapon";
   className = "Weapon";

   shapeFile  = "Add-Ons/Weapon_G36C/G36C.dts";
   rotate     = false;
   mass       = 2;
   density    = 1;
   elasticity = 0.1;
   friction   = 0.9;
   emap       = true;

   uiName       = "Dual G36Cs";
   iconName     = "./Icon_2G36Cs";
   doColorShift = false;

   image   = RightyG36Cimage;
   canDrop = true;
};

datablock ShapeBaseImageData(RightyG36Cimage)
{
   shapeFile = "Add-Ons/Weapon_G36C/G36C.dts";
   emap = true;

   mountPoint = 0; //Right hand
   offset     = "0 0 0";
   eyeOffset  = 0;
   rotation   = ("0 0 0 0");
   
   correctMuzzleVector = true;

   className = "WeaponImage";

   item           = DualG36Citem; //This is actually useless.
   ammo           = " ";
   projectile     = DualG36CsProjectile;
   projectileType = Projectile;

   casing         = G36CshellDebris;
   shellExitDir      = "1 -1.3 1";
   shellExitOffset   = "0 0 0";
   shellExitVariance = 15.0;
   shellVelocity     = 7.0;

   melee = false;
   armReady = true;

   doColorShift = false;

   stateName[0]                    = "Activate";
   stateTransitionOnTriggerDown[0] = "Fire";
   stateSound[0]                   = weaponSwitchSound;

   stateName[1]                    = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1]        = true;

   stateName[2]                = "Fire";
   stateTransitionOnTimeout[2] = "Smoke";
   stateTimeoutValue[2]        = 0.04;
   stateFire[2]                = true;
   stateAllowImageChange[2]    = false;
   stateScript[2]              = "onFire";
   stateWaitForTimeout[2]      = true;
   stateEmitter[2]             = G36CflashEmitter;
   stateEmitterTime[2]         = 0.04;
   stateEmitterNode[2]         = "muzzleNode";
   stateSound[2]               = G36CshotSound;
   stateEjectShell[2]          = true;

   stateName[3]                = "Smoke";
   stateTimeoutValue[3]        = 0.02;
   stateTransitionOnTimeout[3] = "Reload";

   stateName[4]                = "Reload";
   stateTimeoutValue[4]        = 0.04;
   stateTransitionOnTimeout[4] = "Ready";
   stateWaitForTimeout[4]      = true;
   stateScript[4]              = "SecondFire";
};

datablock ShapeBaseImageData(LeftyG36Cimage)
{
   shapeFile = "Add-Ons/Weapon_G36C/G36C.dts";
   emap      = true;

   mountPoint = 1; //Left hand
   offset     = "0 0 0";
   eyeOffset  = 0;
   rotation   = ("0 0 0 0");
   
   correctMuzzleVector = true;

   className = "WeaponImage";

   item           = DualG36Citem;
   ammo           = " ";
   projectile     = DualG36CsProjectile;
   projectileType = Projectile;

   casing          = G36CshellDebris;
   shellExitDir      = "-1 -1.3 1";
   shellExitOffset   = "0 0 0";
   shellExitVariance = 15.0;   
   shellVelocity     = 7.0;

   melee    = false;
   armReady = true;

   doColorShift = false;

   stateName[0]                    = "Activate";
   stateTransitionOnTriggerDown[0] = "Fire";
   stateSound[0]                   = weaponSwitchSound;

   stateName[1]                    = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1]        = true;

   stateName[2]                = "Fire";
   stateTransitionOnTimeout[2] = "Smoke";
   stateTimeoutValue[2]        = 0.04;
   stateFire[2]                = true;
   stateAllowImageChange[2]    = false;
   stateScript[2]              = "onFire";
   stateWaitForTimeout[2]      = true;
   stateEmitter[2]             = G36CflashEmitter;
   stateEmitterTime[2]         = 0.04;
   stateEmitterNode[2]         = "muzzleNode";
   stateSound[2]               = G36CshotSound;
   stateEjectShell[2]          = true;

   stateName[3]                = "Smoke";
   stateTimeoutValue[3]        = 0.02;
   stateTransitionOnTimeout[3] = "Reload";

   stateName[4]                = "Reload";
   stateTimeoutValue[4]        = 0.04;
   stateTransitionOnTimeout[4] = "Ready";
   stateWaitForTimeout[4]      = true;
};

function RightyG36Cimage::SecondFire(%this,%obj,%slot)
{
   %obj.setImageTrigger(1,1); //This makes you fire the image in your left hand
}

function RightyG36Cimage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot); //Calls the usual onMount function
      %obj.mountImage(LeftyG36Cimage, 1); //And mounts the left gun
      %obj.playThread(0, armreadyboth); //Raises both arms
}

function RightyG36Cimage::onUnMount(%this, %obj, %slot)
{
   Parent::OnUnMount(%this, %obj, %slot); //Calls the usual onUnMount
      %obj.unMountImage(1); //Removes the image in the left hand (LeftyG36C)
      %obj.playThread(0, root); //Plays normal standing animation
}

//Now for the spreads - Thanks to Ephialtes (ID 150) for this function
function RightyG36Cimage::onFire(%this,%obj,%slot)
{     
   %projectile = %this.projectile;
   %spread = 0.00175;
      %vector = %obj.getMuzzleVector(%slot);
      %objectVelocity = %obj.getVelocity();
      %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
      %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
      %velocity = VectorAdd(%vector1,%vector2);
      %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
      %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
      %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %velocity = MatrixMulVector(%mat, %velocity);

      %p = new (%this.projectileType)()
      {
         dataBlock = %projectile;
         initialVelocity = %velocity;
         initialPosition = %obj.getMuzzlePoint(%slot);
         sourceObject = %obj;
         sourceSlot = %slot;
         client = %obj.client;
      };
      MissionCleanup.add(%p);
   return %p;
}
function LeftyG36Cimage::onFire(%this,%obj,%slot)
{     
   %projectile = %this.projectile;
   %spread = 0.00175;
      %vector = %obj.getMuzzleVector(%slot);
      %objectVelocity = %obj.getVelocity();
      %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
      %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
      %velocity = VectorAdd(%vector1,%vector2);
      %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
      %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
      %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %velocity = MatrixMulVector(%mat, %velocity);

      %p = new (%this.projectileType)()
      {
         dataBlock = %projectile;
         initialVelocity = %velocity;
         initialPosition = %obj.getMuzzlePoint(%slot);
         sourceObject = %obj;
         sourceSlot = %slot;
         client = %obj.client;
      };
      MissionCleanup.add(%p);
   return %p;
}